New Pages Feed: submitted date sorting option for drafts (2)
Closed, ResolvedPublic8 Story Points

Description

This is the second cohesive, useful feature change that we could roll out to users. The work in the task roughly accomplishes these user stories:

  • As an AfC reviewer, I need to be able to sort the feed by the most recent submission date of the draft, both by newest submission date and oldest submission date.

Specifically, the work is to:

  • For drafts of states "Awaiting review", "Under review", and "Declined", change the "Sort by" radio buttons to a dropdown. If it is easier to change the radio buttons to a dropdown for all use cases (all draft states and for NPP), that's fine.
  • For drafts of states "Awaiting review" and "Under review":
    • The options in the dropdown should be:
      • Created date (newest)
      • Created date (oldest)
      • Submitted date (newest)
      • Submitted date (oldest)
    • "Submitted date" refers to the most recent date that a draft has been submitted to AfC, even if it has been submitted multiple times. Therefore, "Submitted date (oldest)" sorts to those drafts whose most recent submitted date is oldest. Submitted date can be detected in multiple potential ways, giving us options for how to engineer this functionality:
  • For drafts of state "Declined":
    • The options in the dropdown should be:
      • Created date (newest)
      • Created date (oldest)
      • Declined date (newest)
      • Declined date (oldest)
    • "Declined date" refers to the most recent date that a draft has been declined from AfC, even if it has been declined multiple times. Therefore, "Declined date (oldest)" sorts to those drafts whose most recent declined date is oldest. Declined date can be detected in multiple potential ways, giving us options for how to engineer this functionality:
  • For pages not of those three states, the two "Submitted date" options should not be present.
  • The two "Created date" options use the same criteria as the current New Pages Feed uses for "Newest" and "Oldest".

Note: the specifics listed above and the wireframe shown below may be changed by ongoing community conversation around the design, which can be found here.

Here is a wireframe of what the feed would look like after this work, showing the changes to the "Sort by" options:

MMiller_WMF renamed this task from New Pages Feed: submitted date sorting option for drafts to New Pages Feed: submitted date sorting option for drafts (2).May 25 2018, 12:33 AM
MMiller_WMF updated the task description. (Show Details)
MMiller_WMF removed MMiller_WMF as the assignee of this task.
MMiller_WMF updated the task description. (Show Details)May 28 2018, 7:15 PM
MMiller_WMF updated the task description. (Show Details)May 28 2018, 9:28 PM
kaldari set the point value for this task to 8.May 30 2018, 12:04 AM
MMiller_WMF updated the task description. (Show Details)Jun 1 2018, 10:31 PM

@Samwilson @MusikAnimal -- just updated this task to include "Declined date" in the UI for drafts of state "Declined", since you said we would be storing this information anyway.

MusikAnimal moved this task from Ready to In Development on the Community-Tech-Sprint board.

Change 442979 had a related patch set uploaded (by MusikAnimal; owner: MusikAnimal):
[mediawiki/extensions/PageTriage@master] Allow sorting of AfC drafts by submission date

https://gerrit.wikimedia.org/r/442979

Vvjjkkii renamed this task from New Pages Feed: submitted date sorting option for drafts (2) to gbcaaaaaaa.Jul 1 2018, 1:08 AM
Vvjjkkii triaged this task as High priority.
Vvjjkkii removed MusikAnimal as the assignee of this task.
Vvjjkkii updated the task description. (Show Details)
Vvjjkkii removed the point value for this task.
Vvjjkkii removed subscribers: gerritbot, Aklapper.
Niharika renamed this task from gbcaaaaaaa to New Pages Feed: submitted date sorting option for drafts (2).Jul 2 2018, 3:11 PM
Niharika lowered the priority of this task from High to Normal.
Niharika assigned this task to MusikAnimal.
Niharika updated the task description. (Show Details)
Niharika set the point value for this task to 8.
kostajh added a subscriber: kostajh.Jul 3 2018, 5:51 PM

Change 442979 merged by Samwilson:
[mediawiki/extensions/PageTriage@master] Allow sorting of AfC drafts by submission date

https://gerrit.wikimedia.org/r/442979

@Etonkovidova -- this is now ready for your review on Beta. It will be on Test Wiki with the Tuesday train.

A discussion happened on another task, and it's relevant to have it here, as well. I'm quoting the below from T199155. In light of this information, I am going to assign this to the Growth Team since further work is needed.

@SBisson the same field (update_reviewed_timestamp, see ArticleCompileAfcTag.php) is used when a draft is submitted or declined, so the mockup and specs here aren't achievable as is. We have some options

  1. If the draft is in submitted state, show "Submission date" and the update_reviewed_timestamp date, if it's in declined state, show "Declined date" and the update_reviewed_timestamp date. Only one additional date would be added to the individual item view.
  2. Store submission date and declined date as separate fields.

    On a related note, in talking with @MMiller_WMF , we were discussing the UX around having 6 sort options that aren't totally accurate (there are really only 4 options -- "Last AfC action" is what we mean by "Deletion" / "Submission" sort options). Depending on what we do here, we might choose to revisit the six dropdown options.

Thanks, @kostajh.

Kosta helped me realize that the user stories and requirements here are not consistent. We wanted to be able to sort "Declined" drafts by declined date, and "Awaiting review" drafts by submitted date, but that doesn't account for the use case in which they are both present in the list -- namely when the "All" state is selected.

So I see three ways to deal with this:

  1. Change things to store most recent declined date and most recent submitted date separately, display them both in the list for all drafts that have them. Allow sorting by both regardless of draft state.
  2. Keep the data stored the way it is, and list submitted dates for drafts of states "Awaiting review" and "Under review", and list declined dates for drafts of state "Declined", and change the sort option to "Most recent AfC action".
  3. When states "Awaiting review" and "Under review" are selected, the sort options contain "submitted date". When state "Declined" is selected, the sort options contain "declined date", and when states "All" and "Unsubmitted" are selected, the sort options contain neither.

    I would like us to do whatever is the least work, so that we can get things into the hands of the community ASAP, and then we can learn whether other options are preferred.
MMiller_WMF removed MusikAnimal as the assignee of this task.Jul 30 2018, 9:24 PM

@SBisson -- @Etonkovidova and I just noticed that this important task did not make it into the sprint. Do you remember if we had a reason for that? We consider it probably a higher priority than the copyvio work. If we just overlooked it, maybe we should discuss where we could fit it in.

@MMiller_WMF The customization of sort options that was done here was broken during a refactoring (when the html templates were moved from php to js).

I fixed it as part of T199155 in https://gerrit.wikimedia.org/r/#/c/mediawiki/extensions/PageTriage/+/447103/

It is waiting for code review.

Niharika removed a subscriber: Niharika.Aug 6 2018, 5:10 PM

Just to note how this turned out: in terms of the three options quoted above, we went with #3, because that's how the code was originally written but was subsequently broken.

Verified in betalabs and in testwiki (wmf.16). The presence of sorting options is according to the selected state; the sorting order works correctly.

@MMiller_WMF - two limitations to keep in mind:
(1) AfC templates and categories might be added or modified manually, e.g. a page might be created with a category 'AfC declined' - then, the create day will be the same as declined date.

There are some cases where displayed dates in NPP are off by two minutes comparing to the history dates (which should be ok).

(2) User preferences for timezone selection are not reflected on Special:NewPagesFeed. 'View history' respects the timezone preference. It may be confusing for users to see different times when comparing the draft history/recent changes and Special:NewPagesFeed records.

This all looks good. I am moving it to Done.

MMiller_WMF closed this task as Resolved.Aug 16 2018, 8:06 PM
MMiller_WMF claimed this task.